From 737502e4bdd1df8e5bf094e208bd770746e72c5c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 22:00:46 +0000
Subject: [PATCH 1282/2232] Track visibility of exported headers


---

diff --git a/gen/build/src/deps.rs b/gen/build/src/deps.rs
index 4e34835..fb80072 100644
--- a/gen/build/src/deps.rs
+++ b/gen/build/src/deps.rs
@@ -7,7 +7,12 @@ use std::path::PathBuf;
 pub struct Crate {
     pub include_prefix: Option<PathBuf>,
     pub links: Option<OsString>,
-    pub exported_header_dirs: Vec<PathBuf>,
+    pub header_dirs: Vec<HeaderDir>,
+}
+
+pub struct HeaderDir {
+    pub exported: bool,
+    pub path: PathBuf,
 }
 
 impl Crate {
@@ -21,12 +26,14 @@ impl Crate {
         if let Some(links) = &self.links {
             println!("cargo:CXXBRIDGE_LINKS={}", links.to_string_lossy());
         }
-        for (i, exported_dir) in self.exported_header_dirs.iter().enumerate() {
-            println!(
-                "cargo:CXXBRIDGE_DIR{}={}",
-                i,
-                exported_dir.to_string_lossy(),
-            );
+        for (i, header_dir) in self.header_dirs.iter().enumerate() {
+            if header_dir.exported {
+                println!(
+                    "cargo:CXXBRIDGE_DIR{}={}",
+                    i,
+                    header_dir.path.to_string_lossy(),
+                );
+            }
         }
     }
 }
@@ -89,8 +96,11 @@ pub fn direct_dependencies() -> Vec<Crate> {
         crates
             .entry(k)
             .or_default()
-            .exported_header_dirs
-            .extend(dirs.into_iter().map(|(_sort_key, dir)| dir));
+            .header_dirs
+            .extend(dirs.into_iter().map(|(_sort_key, dir)| HeaderDir {
+                exported: true,
+                path: dir,
+            }));
     }
 
     crates.into_iter().map(|entry| entry.1).collect()
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index d5588b1..df2ffad 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -65,7 +65,7 @@ mod syntax;
 mod target;
 mod vec;
 
-use crate::deps::Crate;
+use crate::deps::{Crate, HeaderDir};
 use crate::error::{Error, Result};
 use crate::gen::error::report;
 use crate::gen::Opt;
@@ -183,22 +183,31 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
     let mut this_crate = Crate {
         include_prefix: Some(prj.include_prefix.clone()),
         links: env::var_os("CARGO_MANIFEST_LINKS"),
-        exported_header_dirs: Vec::new(),
+        header_dirs: Vec::new(),
     };
 
     // The generated code directory (include_dir) is placed in front of
     // crate_dir on the include line so that `#include "path/to/file.rs"` from
     // C++ "magically" works and refers to the API generated from that Rust
     // source file.
-    this_crate.exported_header_dirs.push(include_dir);
-    this_crate.exported_header_dirs.extend(crate_dir);
+    this_crate.header_dirs.push(HeaderDir {
+        exported: true,
+        path: include_dir,
+    });
+    if let Some(crate_dir) = crate_dir {
+        this_crate.header_dirs.push(HeaderDir {
+            exported: true,
+            path: crate_dir,
+        });
+    }
     for exported_dir in &CFG.exported_header_dirs {
         if !exported_dir.is_absolute() {
             return Err(Error::ExportedDirNotAbsolute(exported_dir));
         }
-        this_crate
-            .exported_header_dirs
-            .push(PathBuf::from(exported_dir));
+        this_crate.header_dirs.push(HeaderDir {
+            exported: true,
+            path: PathBuf::from(exported_dir),
+        });
     }
     this_crate.print_to_cargo();
 
@@ -215,9 +224,9 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
 
     eprintln!("\nCXX include path:");
     for krate in crates {
-        for header_dir in &krate.exported_header_dirs {
-            build.include(header_dir);
-            eprintln!("  {}", header_dir.display());
+        for header_dir in &krate.header_dirs {
+            build.include(&header_dir.path);
+            eprintln!("  {}", header_dir.path.display());
         }
     }
 

